<?php

/**
 * i-doit
 *
 * Auth: Class for CMDB module authorization rules.
 *
 * @package     i-doit
 * @subpackage  auth
 * @author      Selcuk Kekec <skekec@i-doit.com>
 * @copyright   synetics GmbH
 * @license     http://www.gnu.org/licenses/agpl-3.0.html GNU AGPLv3
 */
class isys_auth_system_qr
    extends
    isys_auth_system
{
    /**
     * Container for singleton instance
     *
     * @var isys_auth_system_qr
     */
    private static $m_instance = NULL;

    /**
     * Global configuration rights
     *
     * @param int $p_right
     *
     * @return bool
     * @author Selcuk Kekec <skekec@i-doit.com>
     */
    public function global_configuration($p_right)
    {
        return $this->qr_config($p_right, 'global');
    } // function

    /**
     * Object type specific configuration rights
     *
     * @param int $p_right
     *
     * @return bool
     * @author Selcuk Kekec <skekec@i-doit.com>
     */
    public function objtype($p_right)
    {
        return $this->qr_config($p_right, 'objtype');
    } // function

    /**
     * Retrieve singleton instance of authorization class
     *
     * @return isys_auth_system_qr
     * @author Selcuk Kekec <skekec@i-doit.com>
     */
    public static function instance()
    {
        // If the DAO has not been loaded yet, we initialize it now.
        if (self::$m_dao === NULL)
        {
            global $g_comp_database;

            self::$m_dao = new isys_auth_dao($g_comp_database);
        } // if

        if (self::$m_instance === NULL)
        {
            self::$m_instance = new self;
        } // if

        return self::$m_instance;
    } // function
} // class