<?php
/**
 * i-doit - Updates.
 *
 * Migration for removing old themes directories
 *
 * @package     i-doit
 * @subpackage  Update
 * @copyright   synetics GmbH
 * @license     http://www.gnu.org/licenses/agpl-3.0.html GNU AGPLv3
 * @author      Dennis Stücken <dstuecken@i-doit.de>
 */

// Initialization
global $g_absdir;

// Path to folder
$l_redbox_dir   = $g_absdir . '/src/themes/redbox';
$l_bluenote_dir = $g_absdir . '/src/themes/bluenote';

// Create filemanager instance
$l_fileman = new isys_component_filemanager();

// Does directory exists?
if (is_dir($l_redbox_dir))
{
	if (is_writeable($l_redbox_dir))
	{
		// Remove entire redbox directory
		$l_fileman->remove_files($l_redbox_dir);
	}
	else throw new Exception('Migration of old themes failed: Error removing directory "'.$l_redbox_dir.'". Set writing rights to your apache user and reload the page or remove directory manually.');
} // if

// Does directory exists?
if (is_dir($l_bluenote_dir))
{
	if (is_writeable($l_bluenote_dir))
	{
		// Remove entire bluenote directory
		$l_fileman->remove_files($l_bluenote_dir);
	}
	else throw new Exception('Migration of old themes failed: Error removing directory "'.$l_bluenote_dir.'". Set writing rights to your apache user and reload the page or remove directory manually.');
} // if

$g_migration_log[] = '<span class="bold grey indent">Migration: Removing old theme directories "redbox" and "bluenote".</span>';