<?php
/**
 * i-doit
 *
 * CMDB Person: Specific category
 *
 * @package    i-doit
 * @subpackage CMDB_Categories
 * @author     Van Quyen Hoang <qhoang@i-doit.org>
 * @copyright  synetics GmbH
 * @license    http://www.gnu.org/licenses/agpl-3.0.html GNU AGPLv3
 */

class isys_cmdb_ui_category_s_person_contact_assign extends isys_cmdb_ui_category_specific
{
	/**
	 * Process method.
	 *
	 * @param   isys_cmdb_dao_category_s_person_contact_assign  $p_cat
	 * @author  Leonard Fischer <lfischer@i-doit.com>
	 */
	public function process (isys_cmdb_dao_category_s_person_contact_assign $p_cat)
	{
		$l_rules = array();

		$this->fill_formfields($p_cat, $l_rules, $p_cat->get_general_data());

		// Apply rules.
		$this->get_template_component()->smarty_tom_add_rules("tom.content.bottom.content", $l_rules);
	} // function


	/**
	 * Process-list method.
	 *
	 * @param   isys_cmdb_dao_category_s_person_contact_assign  $p_cat
	 * @return  bool|null
	 * @author  Dennis Stücken <dstuecken@synetics.de>
	 */
	public function process_list (isys_cmdb_dao_category_s_person_contact_assign $p_cat)
	{
		global $g_cmdb_view;
		global $index_includes;

		$l_gets = $g_cmdb_view
			->get_module_request()
			->get_gets();

		$l_dao_list_contact = new isys_cmdb_dao_list_cats_person_contact_assign($p_cat->get_database_component());

		$l_obj_id = $l_gets[C__CMDB__GET__OBJECT];
		$l_listres = $l_dao_list_contact->get_result(
			null,
			$l_obj_id);

		$l_comp_list = new isys_component_list(null, $l_listres, $l_dao_list_contact, $l_dao_list_contact->get_rec_status());

		$l_new_get[C__CMDB__GET__VIEWMODE] = C__CMDB__VIEW__CATEGORY;
		$l_new_get[C__CMDB__GET__TREEMODE] = C__CMDB__VIEW__TREE_OBJECT;
		$l_new_get[C__CMDB__GET__OBJECT] = $l_gets[C__CMDB__GET__OBJECT];
		$l_new_get[C__CMDB__GET__OBJECTTYPE] = $l_gets[C__CMDB__GET__OBJECTTYPE];
		$l_new_get[C__CMDB__GET__CATS] = $_GET[C__CMDB__GET__CATS] ? $_GET[C__CMDB__GET__CATS] : C__CATS__PERSON_CONTACT_ASSIGNMENT;
		$l_new_get[C__CMDB__GET__CATLEVEL] = "[{isys_catg_contact_list__id}]";
		$l_new_get[C__CMDB__GET__CAT_MENU_SELECTION] = $l_gets[C__CMDB__GET__CAT_MENU_SELECTION];


		$l_comp_list->config(
			$l_dao_list_contact->get_fields(),
			$l_dao_list_contact->make_row_link(),
			"[{isys_catg_contact_list__id}]",
			true);

		$l_comp_list->createTempTable();

		$l_dao_list_contact->set_rec_status($_SESSION["cRecStatusListView"]);

		$l_table = $l_comp_list->getTempTableHtml();

		$this->get_template_component()
			->assign("objectTableList", $l_table)
			->smarty_tom_add_rule("tom.content.bottom.buttons.*.p_bInvisible=1");

		$index_includes['contentbottomcontent'] = "content/bottom/content/object_table_list.tpl";

        isys_component_template_navbar::getInstance()
			->set_active(false, C__NAVBAR_BUTTON__QUICK_PURGE)
			->set_visible(false, C__NAVBAR_BUTTON__QUICK_PURGE);

		return true;
	} // function


	/**
	 * Define if this category is multivalued or not.
	 *
	 * @author  Dennis Stücken <dstuecken@synetics.de>
	 * @return  boolean
	 */
	public function is_multivalued ()
	{
		return true;
	} // function
} // class
?>