<?php
namespace idoit\Module\Search\Index\Observer;

use idoit\Component\ContainerFacade;
use idoit\Component\Protocol\ContainerAware;
use idoit\Component\Provider\DiInjectable;
use idoit\Module\Cmdb\Model\Ci;

/**
 * i-doit
 *
 * Example/Demo Observer
 *
 * Retrieves all indexed documents and adds a debug log entry
 *
 * @package     i-doit
 * @subpackage  Modules
 * @author      Dennis Stücken <dstuecken@i-doit.com>
 * @version     1.7
 * @copyright   synetics GmbH
 * @license     http://www.gnu.org/licenses/agpl-3.0.html GNU AGPLv3
 */
abstract class AbstractObserver implements ContainerAware
{
    use DiInjectable;

    /**
     * AbstractObserver constructor.
     *
     * @param ContainerFacade $container
     */
    public function __construct(ContainerFacade $container)
    {
        $this->setDi($container);
    }

}