/**
 * Extending the String class with methods for finding and linking addresses, cleaning strings etc.
 *
 * @author  Leonard Fischer <lfischer@i-doit.com>
 */

if (!String.hasOwnProperty('linkMailtosInString')) {
	/**
	 * Returns the string with mailto links.
	 *
	 * @returns  String
	 * @author   Leonard Fischer <lfischer@i-doit.com>
	 */
	String.prototype.linkMailtosInString = function () {
		return this.replace(/(\b[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,6}\b)/ig, '<a href="mailto:$1">$1</a>');
	};
}

if (!String.hasOwnProperty('clean')) {
	/**
	 * Removes all non-word-characters (usefull for creating constants)
	 *
	 * @returns  String
	 * @author   Leonard Fischer <lfischer@i-doit.com>
	 */
	String.prototype.clean = function () {
		return this.replace(/\W/ig, '');
	};
}