<?php
namespace idoit\Module\Search\Index\Observer;

use idoit\Component\Protocol\ContainerAware;
use idoit\Component\Provider\DiInjectable;
use idoit\Module\Cmdb\Model\Ci;
use idoit\Module\Search\Index\Protocol\Observer;
use idoit\Module\Search\Index\Protocol\Document;
use idoit\Module\Search\Index\Protocol\ObservableIndexManager;

/**
 * i-doit
 *
 * Example/Demo Observer
 *
 * Retrieves all indexed documents and adds a debug log entry
 *
 * @package     i-doit
 * @subpackage  Modules
 * @author      Dennis Stücken <dstuecken@i-doit.com>
 * @version     1.7
 * @copyright   synetics GmbH
 * @license     http://www.gnu.org/licenses/agpl-3.0.html GNU AGPLv3
 */
class DemoObserver implements Observer, ContainerAware
{
    use DiInjectable;

    /**
     * @param Document             $document
     * @param ObservableIndexManager $indexManager
     */
    public function update(Document $document, ObservableIndexManager $indexManager)
    {
        $this->getDi()->logger->addDebug('Received document: ' . var_export($document, true));
    }

}