<?php
namespace idoit\Module\Search\Index\Traits;

/**
 * i-doit
 *
 * Search index counter trait
 *
 * Provides index counter member variables
 *
 * @package     i-doit
 * @subpackage  Modules
 * @author      Dennis Stücken <dstuecken@i-doit.com>
 * @version     1.7
 * @copyright   synetics GmbH
 * @license     http://www.gnu.org/licenses/agpl-3.0.html GNU AGPLv3
 */
trait IndexCounterTrait
{
    /**
     * Amount of indexed documents
     *
     * @var int
     */
    private $indexedDocuments = 0;

    /**
     * Amount of indexed property values
     *
     * @var int
     */
    private $indexedItems = 0;

    /**
     * @return int
     */
    public function getIndexedItems()
    {
        return $this->indexedItems;
    }

    /**
     * @return int
     */
    public function getIndexedDocuments()
    {
        return $this->indexedDocuments;
    }
}