<?php
/**
 * i-doit - Documentation and CMDB solution for IT environments
 *
 * This file is part of the i-doit framework. Modify at your own risk.
 *
 * Please visit http://www.i-doit.com/license for a full copyright and license information.
 *
 * @version     1.7
 * @package     i-doit
 * @author      synetics GmbH
 * @copyright   synetics GmbH
 * @url         http://www.i-doit.com
 * @license     http://www.i-doit.com/license
 */
namespace idoit\Component\Helper; use idoit\Component\Provider\Singleton; use idoit\Exception\OutOfMemoryException; class Memory { use Singleton; protected $maxMemory = 0; public function getMaxMemory() { return $this->maxMemory; } public function getMemoryUsage() { return memory_get_usage(true); } public function getMemoryPeakUsage() { return memory_get_peak_usage(true); } public function isMemoryAvailable($amount = 1024) { return !(($this->getMemoryUsage() + $amount) > $this->maxMemory); } public function outOfMemoryBreak($amount = 1024) { if (!$this->isMemoryAvailable($amount)) { throw new OutOfMemoryException(sprintf('Maximum allowed memory reached. (%s MB). You can increase this limit in your php configuration: http://php.net/manual/en/ini.core.php#ini.memory-limit', $this->maxMemory / 1024 / 1024)); } } public function __construct() { $this->maxMemory = Filesize::toBytes(ini_get('memory_limit')); } }