<?php

/**
 * i-doit core classes
 *
 * @package     i-doit
 * @subpackage  Core
 * @author      Dennis Stücken <dstuecken@synetics.de>
 * @copyright   synetics GmbH
 * @license     http://www.gnu.org/licenses/agpl-3.0.html GNU AGPLv3
 */
class isys_string
{
    /**
     * Split string by delimiters | ; ,
     *
     * @param $p_str
     *
     * @return array
     */
    public static function split($p_str)
    {
        return array_map('trim', preg_split('/[|;,]/', $p_str, 0, PREG_SPLIT_NO_EMPTY));
    }

    /**
     * Highlight string and preserve it's original case
     *
     * @param $needle
     * @param $haystack
     *
     * @return string
     */
    public static function highlight($needle, $haystack)
    {
        $needle = isys_helper::sanitize_text(strip_tags($needle));

        $ind = stripos($haystack, $needle);
        $len = strlen($needle);
        if ($ind !== false)
        {
            return substr($haystack, 0, $ind) . "<span class=\"searchHighlight\">" . substr($haystack, $ind, $len) . "</span>" . self::highlight($needle, substr($haystack, $ind + $len));
        }
        else return $haystack;
    }
}