[{isys_group name="tom.content.table"}]
[{if !$options.disableTableConfig || !$options.tableConfigURL}]
	<a href="[{$options.tableConfigURL}]" class="mainTableConfigLink" id="mainTableListConfig">
		<img src="[{$dir_images}]icons/silk/table_edit.png" title="[{isys type="lang" ident="LC__CMDB__LIST_CONFIGURE"}]" />
	</a>
[{/if}]

[{if $options.resizeColumns && $options.resizeColumnAjaxURL}]
	<span id="[{$unique}]-column-resetter" class="mainTableConfigLink">
		<img src="[{$dir_images}]icons/silk/table.png" title="[{isys type="lang" ident="LC__MODULE__CMDB__RESTORE_DEFAULT_LIST_WIDTH"}]" />
	</span>
[{/if}]

[{if $options.filter && $options.filterColumns}]
	<div class="input-group mainTableFilterInput search">
		[{isys type="f_text" name="`$unique`-filter" inputType="search"}]

		<div class="input-group-addon mouse-pointer" id="[{$unique}]-filter-button" title="[{isys type="lang" ident="LC__CMDB__OBJECT_LIST__FILTER_TOOLTIP"}]">
			<img src="[{$dir_images}]icons/silk/zoom.png" />
		</div>
	</div>
	<div class="input-group mainTableFilterInput">
		<div class="input-group-addon input-group-addon-unstyled">
			<span class="mr5">[{isys type="lang" ident="LC_UNIVERSAL__FILTER"}]</span>
		</div>
		[{isys type="f_dialog" name="`$unique`-filter-field"}]
	</div>
[{/if}]
	<div id="mainTableRowsPerPage" class="input-group mainTableFilterInput" style="width: 150px;">
		<div class="input-group-addon input-group-addon-unstyled">[{isys type="lang" ident="LC__CMDB__LIST_SHOW"}]</div>
		[{isys type="f_dialog" name="`$unique`-rows-per-page"}]
		<div class="input-group-addon input-group-addon-unstyled">/ [{$rows}] [{isys type="lang" ident="LC__UNIVERSAL__ENTRIES"}]</div>
	</div>

	<div id="[{$unique}]-pager" class="mainTablePager p5">
		[{$pager}]
	</div>
[{if count($data)}]
	<table id="[{$unique}]" class="mainTable border-top" style="table-layout: fixed;">
		<colgroup>
			[{if $options.enableCheckboxes}]
				<col />
			[{/if}]
			[{foreach $header as $field}]
				<col />
			[{/foreach}]
		</colgroup>
		<thead>
		<tr>
			[{if $options.enableCheckboxes}]
				<th class="no-drag">
					<span>
						<label class="mainTableCheckbox"><input type="checkbox" title="[{isys type="lang" ident="LC__MODULE__CMDB__LIST_CHECK_ALL_CURRENT_PAGE"}]" name="table_id_all[]" value="0" /></label>
					</span>
				</th>
			[{/if}]
			[{foreach $header as $fieldTitle => $field}]
				<th>
					[{if $options.order}]<img src="[{$dir_images}]icons/silk/bullet_arrow_up.png" class="sort-arrow opacity-30 hide">[{/if}]
					<span class="overflowable" title="[{$fieldTitle}]">[{$field}]</span>
				</th>
			[{/foreach}]
		</tr>
		</thead>
		<tbody class="mainTableHover">
		[{foreach $data as $row}]
			<tr data-id="[{$row.__id__}]">
				[{foreach $row as $key => $col}]
					[{if $options.enableCheckboxes && $key == '__id__'}]
						<td>
							[{if $options.dragDrop}]<div class="drag-handle"></div>[{/if}]
							<label class="mainTableCheckbox"><input type="checkbox" name="table_ids[]" value="[{$col}]" /></label>
						</td>
					[{else}]
						<td><span class="overflowable">[{$col}]</span></td>
					[{/if}]
				[{/foreach}]
			</tr>
		[{/foreach}]
		</tbody>
	</table>
[{else}]
	<div class="m5 p5 box-blue">
		<img src="[{$dir_images}]icons/silk/information.png" class="vam mr5" /><span class="vam">[{isys type="lang" ident="LC__CMDB__FILTER__NOTHING_FOUND_STD"}]</span>
	</div>
[{/if}]
	<script type="application/javascript">
		(function () {
			'use strict';

			var $table             = $('[{$unique}]'),
			    columnSizes        = '[{$options.columnSizes|json_encode|escape:"javascript"}]'.evalJSON(),
			    $columnResetButton = $('[{$unique}]-column-resetter'),
			    $rowsPerPage       = $('[{$unique}]-rows-per-page'),
			    $filter            = $('[{$unique}]-filter'),
			    $filterField       = $('[{$unique}]-filter-field'),
			    $filterButton      = $('[{$unique}]-filter-button'),
			    $pager             = $('[{$unique}]-pager');

			if (!window.tableCache || typeof window.tableCache !== 'object')
			{
				// Define the tableCache.
				window.tableCache = {"[{$pagerCurrentUrl}]": window.replaceTablePlaceholders($('main_content').innerHTML.trim())};
			}

			if (!Object.isArray(columnSizes))
			{
				columnSizes = [];
			}

			if ($table)
			{
				var tableComp = new TableComponent($table, {
					dragDrop:               [{if $options.dragDrop}]true[{else}]false[{/if}],
					dragDropBoxContent:     '<img src="' + window.dir_images + 'icons/silk/database_copy.png" class="mr5"><span>%count% [{isys type="lang" ident="LC__CMDB__OBJECT_LIST__DRAG_OBJECTS"}]</span>',
					checkboxes:             [{if $options.enableCheckboxes}]true[{else}]false[{/if}],
					resizeColumns:          [{if $options.resizeColumns}]true[{else}]false[{/if}],
					resizeColumnAjaxURL:    '[{$options.resizeColumnAjaxURL}]',
					columnSizes:            columnSizes,
					order:                  [{if $options.order}]true[{else}]false[{/if}],
					orderColumns:           '[{$options.orderColumns|json_encode|escape:"javascript"}]'.evalJSON(),
					currentOrderColumn:     '[{$smarty.get.orderBy|default:$options.orderDefaultColumn}]',
					currentOrderDirection:  '[{$smarty.get.orderByDir|default:$options.orderDefaultDirection}]',
					orderAscendingMessage:  '[{isys type="lang" ident="LC__CMDB__LIST_ORDER_ASCENDING"}]',
					orderDescendingMessage: '[{isys type="lang" ident="LC__CMDB__LIST_ORDER_DESCENDING"}]',
					rowClick:               [{if $options.rowClick}]true[{else}]false[{/if}],
					rowClickUrl:            '[{$options.rowClickURL}]',
					keyboardCommands:       [{if $options.keyboardCommands}]true[{else}]false[{/if}],
					loadingMessage:         '[{isys type="lang" ident="LC__UNIVERSAL__LOADING"}]'
				});
			}

			if ($columnResetButton && tableComp)
			{
				$columnResetButton.on('click', function () {
					tableComp.resetColumns();
				})
			}

			if ($rowsPerPage)
			{
				$rowsPerPage.on('change', function () {
					var urlParts = document.location.href.parseQuery();

					urlParts.rowsPerPage = $rowsPerPage.getValue();
					delete urlParts['[{\idoit\Component\Table\Table::CURRENT_PAGE}]'];

					document.location.href = window.www_dir + '?' + Object.toQueryString(urlParts);
				});
			}

			if ($filter && $filterField && $filterButton)
			{
				$filter.on('keydown', function (ev) {
					if (ev.keyCode === 13)
					{
						$filterButton.simulate('click');

						ev.preventDefault();
					}
				});

				$filterButton.on('click', function () {
					var urlParts = document.location.href.parseQuery();

					if ($filter.getValue().clean().empty())
					{
						// The filter is empty - reset the search and display the unfiltered list.
						delete urlParts.tableFilter;
						delete urlParts.tableFilterField;
					}
					else
					{
						urlParts.tableFilter = $filter.getValue();
						urlParts.tableFilterField = $filterField.getValue();
						delete urlParts['[{\idoit\Component\Table\Table::CURRENT_PAGE}]'];
					}

					urlParts.filtered = 1;

					document.location.href = window.www_dir + '?' + Object.toQueryString(urlParts);
				});

				[{if !$smarty.get.tableFilterField}]
				// Sort of "preselect" the first "__title" field that appears.
				if ($filterField.down('option[value$="__title"]'))
				{
					$filterField.setValue($filterField.down('option[value$="__title"]').readAttribute('value'));
				}
				[{/if}]
			}

			if ($pager)
			{
				$pager.on('click', '.dots', function () {
					var page = prompt('[{isys type="lang" ident="LC__UNIVERSAL__JUMP_TO_PAGE"}]', '1');

					if (page === null)
					{
						// User clicked "cancel" - do nothing.
						return;
					}

					page = parseInt(page);

					if (isNaN(page))
					{
						idoit.Notify.warning('[{isys type="lang" ident="LC__CMDB__OBJECT_LIST__INVALID_PAGE_NUMBER"}]', {life: 5});
						return;
					}

					if (page < 1)
					{
						idoit.Notify.warning('[{isys type="lang" ident="LC__CMDB__OBJECT_LIST__PAGE_NUMBER_DOES_NOT_EXIST"}]'.replace('%pages%', '[{$options.pages}]'), {life: 5});
						return;
					}

					if (page > parseInt('[{$options.pages}]'))
					{
						idoit.Notify.warning('[{isys type="lang" ident="LC__CMDB__OBJECT_LIST__PAGE_NUMBER_DOES_NOT_EXIST"}]'.replace('%pages%', '[{$options.pages}]'), {life: 5});
						return;
					}

					$pager.fire('pager:loadAndDisplayPage', {url: ('[{$pagerUrl}]'.replace('%25page%25', page))});
				});

				$pager.on('click', 'a', function (ev) {
					var $page = ev.findElement('a'),
					    url   = $page.readAttribute('href');

					// Prevent the click on the link (opening in a new tab still works)!
					ev.preventDefault();

					// Setting the URL.
					window.pushState({}, '', url);

					// Display a loading sign.
					$page.update(new Element('img', {src: window.dir_images + 'ajax-loading.gif'}));

					// If the URL has already been cached simply display it!
					$pager.fire('pager:loadAndDisplayPage', {url: url});
				});

				$pager.on('pager:loadAndDisplayPage', function (ev) {
					var url = ev.memo.url;

					$pager.fire('pager:loadPage', {
						url:      url,
						callback: function () {
							$('main_content').update(window.tableCache[url]);
						}
					});
				});

				$pager.on('pager:loadPage', function (ev) {
					var url      = ev.memo.url,
					    callback = ev.memo.callback;

					// If the URL has already been cached simply display it!
					if (!window.tableCache.hasOwnProperty(url))
					{
						// Ajax pagination.
						new Ajax.Request(url + '&[{$smarty.const.C__GET__AJAX_CALL}]=category&[{$smarty.const.C__GET__AJAX}]=1', {
							method:     'get',
							onComplete: function (xhr) {
								window.tableCache[url] = window.replaceTablePlaceholders(xhr.responseText.trim());

								if (Object.isFunction(callback))
								{
									callback();
								}
							}
						});
					}
					else
					{
						if (Object.isFunction(callback))
						{
							callback();
						}
					}
				});

				[{if $pagerNextUrl}]
				// Preload the next page.
				if (!window.tableCache.hasOwnProperty('[{$pagerNextUrl}]'))
				{
					$pager.fire('pager:loadPage', {url: '[{$pagerNextUrl}]'});
				}
				[{/if}]
			}

			[{if isys_usersettings::get('introjs.1_8.objectList', 0) === 0}]
			idoit.Require.require('introjs', function () {
				var intro = introJs();
				intro.setOptions(
					{
						steps: [
							{
								intro: "[{isys type="lang" ident="LC__LIST__INTRO__WELCOME"}]"
							},
							{
								element:  document.querySelector('#mainTableListConfig'),
								intro:    "[{isys type="lang" ident="LC__LIST__INTRO__CONFIG"}]",
								position: "left"
							},
							{
								element:  document.querySelector('#[{$unique}]-column-resetter'),
								intro:    "[{isys type="lang" ident="LC__LIST__INTRO__CONFIG_RESIZE"}]",
								position: "left"
							},
							{
								element:  document.querySelector('.mainTableFilterInput'),
								intro:    "[{isys type="lang" ident="LC__LIST__INTRO__FILTER"}]",
								position: "left"
							},
							{
								element: document.querySelector('#mainTableRowsPerPage'),
								intro:   "[{isys type="lang" ident="LC__LIST__INTRO__ROWS_PER_PAGE"}]"
							},
							{
								element: document.querySelector('.mainTablePager'),
								intro:   "[{isys type="lang" ident="LC__LIST__INTRO__PAGER"}]"
							}
						],
						nextLabel:          '[{isys type="lang" ident="LC__UNIVERSAL__BUTTON_NEXT"}]',
						prevLabel:          '[{isys type="lang" ident="LC__UNIVERSAL__BACK"}]',
						skipLabel:          '[{isys type="lang" ident="LC__UNIVERSAL__BUTTON_CANCEL"}]',
						doneLabel:          '[{isys type="lang" ident="LC_POPUP_WIZARD_FILE__COMPLETE"}]',
						hidePrev:           true,
						hideNext:           true,
						keyboardNavigation: true,
						exitOnEsc:          true
					}
				);
				intro.start();
			});

			[{isys_usersettings::set('introjs.1_8.objectList', '1')}]
			[{/if}]
		})();
	</script>
[{/isys_group}]